#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16

extern unsigned short __checksum;

extern unsigned int __checksum_begin1;
extern unsigned int __checksum_end1;

extern unsigned int __checksum_begin2;
extern unsigned int __checksum_end2;

extern unsigned short slow_crc16(unsigned short,unsigned char *,unsigned int);
extern unsigned short fast_crc16(unsigned short,unsigned char *,unsigned int);

const int zero=0;

int main(void)
{
     unsigned short sum = 0;

#ifdef SLOW_CRC16
     sum = slow_crc16(sum,(unsigned char *)&__checksum_begin1, (unsigned int)&__checksum_end1 -(unsigned int)&__checksum_begin1 +1);
     sum = slow_crc16(sum,(unsigned char *)&__checksum_begin2, (unsigned int)&__checksum_end2 -(unsigned int)&__checksum_begin2 +1);
     sum = slow_crc16(sum,(unsigned char *)&zero, 2);
#elif defined FAST_CRC16
     sum = fast_crc16(sum,(unsigned char *)&__checksum_begin1, (unsigned int)&__checksum_end1 -(unsigned int)&__checksum_begin1 +1);
     sum = fast_crc16(sum,(unsigned char *)&__checksum_begin2, (unsigned int)&__checksum_end2 -(unsigned int)&__checksum_begin2 +1);
#endif

     if (sum != __checksum)
     {
          printf("*** Checksum failed: 0x%hX (counted) vs 0x%hX (from ielftool)\n", sum, __checksum);
     }
     else
     {
          printf("+++ Checksum 0x%hX is correct!\n", __checksum);
     }
}
